<?php
/*
Plugin Name: Diwali Greetings
Plugin URI: http://www.karthik.sg/
Author: Alagappan Karthikeyan
Author URI: http://www.karthik.sg/
Description: Diwali Greeting & Fireworks for your blog, see the <a href="http://projects.karthik.sg/wp/">live demo</a>.
Version: 1.0
*/

// Install hook
register_activation_hook(__FILE__,'nkfireworks_install');
function nkfireworks_install() {
	if (!get_option('nkfireworks_rockets')) {
	    update_option('nkfireworks_rockets', '5');
	    update_option('nkfireworks_timeout', '80');
	    update_option('nkfireworks_maxstepx', '10');
	    update_option('nkfireworks_maxstepy', '10');
	    //update_option('nkfireworks_selected', 'flake2.gif,flake3.gif');
	    update_option('nkfireworks_maxtime', '20');
	    update_option('nkfireworks_uri', '');
	    update_option('nkfireworks_precise', '');
	    update_option('nkfireworks_flakesize', '40');
		update_option('nkfireworks_homelink', 'No');
	}
}

// Hook for adding admin menus
add_action('admin_menu', 'nkfireworks_add_pages');
if (get_option('nkfireworks_uri')) {
	if (
		(
			get_option('nkfireworks_precise') !== 'on' &&
			strpos($_SERVER['REQUEST_URI'], get_option('nkfireworks_uri')) > 0
		) ||
		(
			get_option('nkfireworks_precise') === 'on' &&
			strcmp($_SERVER['REQUEST_URI'], get_option('nkfireworks_uri')) === 0
		)
	) {
		add_action('wp_head', 'nkfireworks_head');
		add_action('wp_footer', 'nkfireworks_footer');
	}
} // default: enable
elseif  (!get_option('nkfireworks_uri')) {
	add_action('wp_head', 'nkfireworks_head');
	add_action('wp_footer', 'nkfireworks_footer');
}
add_action('wp_footer', 'nkfireworks_homelink');


function nkfireworks_add_pages() {
	add_options_page('Diwali Fireworks', 'Diwali Fireworks', 10, 'nkfireworks', 'nkfireworks_options_page');
	function nkfireworks_options_page() { ?>
		<div class="wrap" style="margin: 0 5mm; max-width: 100ex;">
		<?php
			if ( strlen($_POST['nkfireworks_rockets']) > 0 ) {
				echo '<div id="message" class="updated fade">Form submitted.<br />';
				echo "Settings changed";
				update_option('nkfireworks_rockets', $_POST['nkfireworks_rockets']);
				update_option('nkfireworks_uri', $_POST['nkfireworks_uri']);
				update_option('nkfireworks_precise', $_POST['nkfireworks_precise']);
				update_option('nkfireworks_timeout', $_POST['nkfireworks_timeout']);
				update_option('nkfireworks_maxstepx', $_POST['nkfireworks_maxstepx']);
				update_option('nkfireworks_homelink', $_POST['nkfireworks_homelink']);
				update_option('nkfireworks_maxstepy', $_POST['nkfireworks_maxstepy']);
				update_option('nkfireworks_maxtime', $_POST['nkfireworks_maxtime']);
				//if ($_POST['nkfireworks_selected']) {
				//	update_option('nkfireworks_selected', implode(',', $_POST['nkfireworks_selected']));
				//}
				//else {
    			//	update_option('nkfireworks_selected', 'flake2.gif,flake3.gif');
				//}
				update_option('nkfireworks_flakesize', $_POST['nkfireworks_flakesize']);
				echo '</div>';
			}
		?>
		<h2>Fireworks</h2>
		<p>
		If you have any problems using this plugin, please read the <a href="http://projects.karthik.sg/wp/">FAQ</a> first.
		</p>
        <hr>
		<h2>Settings</h2>
		<form action="" method="post">
			Show how many rockets?
			<select name="nkfireworks_rockets" >
			<?php
				$select = get_option('nkfireworks_rockets'); 
				for ($i = 10 ; $i >= 0; $i--) {
					if ( $i == $select ) {
						echo "<option selected>$i</option>\n";
					}
					else {
						echo "<option>$i</option>\n";
					}
				}
			?>
			</select>
			<br />

			<h3>Pro settings</h3>
			Stop fireworks after how many seconds?
			<input type="text" name="nkfireworks_maxtime" value="<?php echo get_option('nkfireworks_maxtime'); ?>" size="3">
			<br />
			Overall speed (timeout in milliseconds between moves)? 
			<select name="nkfireworks_timeout" >
			<?php
				$select = get_option('nkfireworks_timeout'); 
				for ($i = 40 ; $i <= 500; $i = $i + 40) {
					if ( $i == $select ) {
						echo "<option selected>$i</option>\n";
					}
					else {
						echo "<option>$i</option>\n";
					}
				}
			?>
			</select>
			<br />
			Show rockets only on pages whose URI contains
			<input type="text" value="<?php echo get_option('nkfireworks_uri'); ?>" name="nkfireworks_uri" />
			<br />
			Show rockets only if the URI given above and the URI are equal
			($_SERVER['REQUEST_URI'] == URI string)?
		   	<input type="checkbox" name="nkfireworks_precise" <?php
				if (get_option('nkfireworks_precise') === 'on') {
					echo "checked";
				}?>>
			<br />
			Hide the &quot;Powered by&quot; message in the footer?
			<select name="nkfireworks_homelink">
			<option <?php
				if (get_option('nkfireworks_homelink') === 'Yes') {
					echo "selected";
				}?>>Yes</option>
			<option <?php
				if (get_option('nkfireworks_homelink') !== 'Yes') {
					echo "selected";
				}?>>No</option>
			</select>
			<br />
			<input type="submit" value="Update settings" />
		</form>
		</div>
		<?php
	}
}

// set necessary JS variables and include the script
function nkfireworks_head() { ?>
<!-- nkfireworks -->
<script type="text/javascript">
nkf = new Object;
nkf.rockets = <?php
	echo get_option('nkfireworks_rockets');
?>;
nkf.timeout = <?php
	echo get_option('nkfireworks_timeout');
?>;
//nkfireworks_maxstepx = 10;
nkf.maxstepy = 10;
//nkf.flakesize = <?php
	echo get_option('nkfireworks_flakesize');
?>;
nkf.flakesize = 20;
nkf.maxtime = <?php
	echo get_option('nkfireworks_maxtime') * 1000;
?>;
nkf.picsurl = '<?php echo get_bloginfo('wpurl') . '/' . PLUGINDIR . '/diwali/pics/';
?>';
</script>
<script src="<?php echo get_bloginfo('wpurl') . '/' . PLUGINDIR . '/diwali/fireworks.js'; ?>" type="text/javascript"></script>
<!-- /nkfireworks -->
<?php
}

// Put the images into the HTML code
function nkfireworks_footer() {
	$rockets = get_option('nkfireworks_rockets');


	for ($i = 0; $i < $rockets; $i++) {
				echo "\n<img id=\"nkf" . $i . "\" src=\"" . get_bloginfo('wpurl') . '/' . PLUGINDIR . '/diwali/pics/rocket.gif" style="position: fixed; top: -1000px; border: 0; z-index:1000; visibility: hidden; " class="nkfireworks" alt="fireworks" />';
	}
}

function nkfireworks_homelink() {
	if (
			!(get_option('nkfireworks_homelink') === 'Yes')
	) { ?>
		<a href="http://www.karthik.sg/wp_projects/jaxcon/">Wordpress Diwali Greetings</a>
		<br />
<?php
	}
}

function nkfireworks_dirArray() {
	$picpath = ABSPATH . '/' . PLUGINDIR . '/diwali/pics/';
	if ( $picdir = opendir($picpath) ) {
		while($entryName = readdir($picdir)) {

			if ( $entryName == '.' || $entryName == '..' || $entryName == '.svn' ) {
				continue;
			}
			$dirArray[] = $entryName;
		}
	}
	sort($dirArray);
	closedir($picdir);
	return $dirArray;
}
?>
